<!DOCTYPE html>

<html>
<head>
<meta charset="ISO-8859-1">
<title>The Simplest Spring Embedder</title>
</head>
<style>
.node-active{
  stroke: #555;
  stroke-width: 1.5px;
}

.link-active {
	stroke-width: 1,5;
	stroke-opacity: 2;
}

.center {
  margin-left: auto;
  margin-right: auto;
}


</style>
<body id="body">

<center><h3>The Simplest Spring Embedder</h3></center>

<table class="center">
<tr>
	<td>
             <input type="button" id="useDefault" value="Use default data" onclick="useDefaultData();" />
	</td>
	<td><button onClick="draw()" style="width:81px">Draw</button></td>
<tr>
<tr>
	<td>
             <input type="button" id="loadFileFromClient" value="Load from client" onclick="document.getElementById('files').click();" />
             <input type="file" style="display:none;" id="files" name="file" accept=".json" onclick="enableDrawResume()"/>
	</td>
	<td><button onClick="resume()" style="width:81px">Resume</button></td>
</tr>
</table>

<center>
<svg style="border-style: solid">
</center>

<table class="center">
<tr>
	<td align="right">Charge:</td>
	<td><input id="charge" type="number" value="5" onchange="resume()"></td>
	<td>&nbsp;&nbsp;&nbsp;</td>
	<td align="right">Iterations:</td>
	<td><input id="iterations" type="number" value="1000""></td>
</tr><tr>
	<td align="right">Link Distance:</td>
	<td><input id="linkDistance" type="number" value="15" onchange="resume()"></td>
	<td>&nbsp;&nbsp;&nbsp;</td>
	<td align="right">Gravity:</td>
	<td><input id="gravity" type="number" value="0.002" onchange="resume()"></td>
<tr>
	<td align="right">Link Strength:</td>
	<td><input id="linkStrength" type="number" value="400" onchange="resume()"></td>
</tr>
</table>

<p align="right">Thanks to Matteo Bellatreccia</p>

<script src="lib/d3.min.js"></script>
<script>
document.getElementById('files').addEventListener('change', handleFileSelect, false);
var reader;
var nodi ={};
var links = {};
var nodi2;
var link;
var svg;
var graph;
var primaVolta = true;
var seed = 1;
var width = 900;
var height = 600;

var k_spring;
var k_el;
var g = 90;  // questa è la gravità
var daFile = false; // whether data comes from a file
var defaultData = false; // whether data is the default

function useDefaultData() {
	defaultData = true;
        enableDrawResume(); 
}

function handleFileSelect(evt) {
    	var file = evt.target.files[0];    
	reader = new FileReader();
	reader.readAsText(file);
  	reader.onloadend= (function() {
  		daFile = true;
  	});
}

function draw(){

	var linkedByIndex = {};
	seed = 1;
	if (primaVolta){
		primaVolta=false;
	} else {	
		svg.remove();
	}

	var color = d3.scale.category20();


	if(daFile){
    		var graph = JSON.parse(reader.result);
    		nodi = graph.nodes;
    		links = graph.links;
    	}

        if(defaultData) {
		nodi = [
                          {"name":"Myriel","group":1},
                          {"name":"Napoleon","group":1},
                          {"name":"Mlle.Baptistine","group":1},
                          {"name":"Mme.Magloire","group":1},
                          {"name":"CountessdeLo","group":1},
                          {"name":"Geborand","group":1},
                          {"name":"Champtercier","group":1},
                          {"name":"Cravatte","group":1},
                          {"name":"Count","group":1},
                          {"name":"OldMan","group":1},
                          {"name":"Labarre","group":2},
                          {"name":"Valjean","group":2},
                          {"name":"Marguerite","group":3},
                          {"name":"Mme.deR","group":2},
                          {"name":"Isabeau","group":2},
                          {"name":"Gervais","group":2},
                          {"name":"Tholomyes","group":3},
                          {"name":"Listolier","group":3},
                          {"name":"Fameuil","group":3},
                          {"name":"Blacheville","group":3},
                          {"name":"Favourite","group":3},
                          {"name":"Dahlia","group":3},
                          {"name":"Zephine","group":3},
                          {"name":"Fantine","group":3},
                          {"name":"Mme.Thenardier","group":4},
                          {"name":"Thenardier","group":4},
                          {"name":"Cosette","group":5},
                          {"name":"Javert","group":4},
                          {"name":"Fauchelevent","group":0},
                          {"name":"Bamatabois","group":2},
                          {"name":"Perpetue","group":3},
                          {"name":"Simplice","group":2},
                          {"name":"Scaufflaire","group":2},
                          {"name":"Woman1","group":2},
                          {"name":"Judge","group":2},
                          {"name":"Champmathieu","group":2},
                          {"name":"Brevet","group":2},
                          {"name":"Chenildieu","group":2},
                          {"name":"Cochepaille","group":2},
                          {"name":"Pontmercy","group":4},
                          {"name":"Boulatruelle","group":6},
                          {"name":"Eponine","group":4},
                          {"name":"Anzelma","group":4},
                          {"name":"Woman2","group":5},
                          {"name":"MotherInnocent","group":0},
                          {"name":"Gribier","group":0},
                          {"name":"Jondrette","group":7},
                          {"name":"Mme.Burgon","group":7},
                          {"name":"Gavroche","group":8},
                          {"name":"Gillenormand","group":5},
                          {"name":"Magnon","group":5},
                          {"name":"Mlle.Gillenormand","group":5},
                          {"name":"Mme.Pontmercy","group":5},
                          {"name":"Mlle.Vaubois","group":5},
                          {"name":"Lt.Gillenormand","group":5},
                          {"name":"Marius","group":8},
                          {"name":"BaronessT","group":5},
                          {"name":"Mabeuf","group":8},
                          {"name":"Enjolras","group":8},
                          {"name":"Combeferre","group":8},
                          {"name":"Prouvaire","group":8},
                          {"name":"Feuilly","group":8},
                          {"name":"Courfeyrac","group":8},
                          {"name":"Bahorel","group":8},
                          {"name":"Bossuet","group":8},
                          {"name":"Joly","group":8},
                          {"name":"Grantaire","group":8},
                          {"name":"MotherPlutarch","group":9},
                          {"name":"Gueulemer","group":4},
                          {"name":"Babet","group":4},
                          {"name":"Claquesous","group":4},
                          {"name":"Montparnasse","group":4},
                          {"name":"Toussaint","group":5},
                          {"name":"Child1","group":10},
                          {"name":"Child2","group":10},
                          {"name":"Brujon","group":4},
                          {"name":"Mme.Hucheloup","group":8}
                     ];
	     links = [
                          {"source":1,"target":0,"value":1},
                          {"source":1,"target":0,"value":1},
                          {"source":2,"target":0,"value":8},
                          {"source":3,"target":0,"value":10},
                          {"source":3,"target":2,"value":6},
                          {"source":4,"target":0,"value":1},
                          {"source":5,"target":0,"value":1},
                          {"source":6,"target":0,"value":1},
                          {"source":7,"target":0,"value":1},
                          {"source":8,"target":0,"value":2},
                          {"source":9,"target":0,"value":1},
                          {"source":11,"target":10,"value":1},
                          {"source":11,"target":3,"value":3},
                          {"source":11,"target":2,"value":3},
                          {"source":11,"target":0,"value":5},
                          {"source":12,"target":11,"value":1},
                          {"source":13,"target":11,"value":1},
                          {"source":14,"target":11,"value":1},
                          {"source":15,"target":11,"value":1},
                          {"source":17,"target":16,"value":4},
                          {"source":18,"target":16,"value":4},
                          {"source":18,"target":17,"value":4},
                          {"source":19,"target":16,"value":4},
                          {"source":19,"target":17,"value":4},
                          {"source":19,"target":18,"value":4},
                          {"source":20,"target":16,"value":3},
                          {"source":20,"target":17,"value":3},
                          {"source":20,"target":18,"value":3},
                          {"source":20,"target":19,"value":4},
                          {"source":21,"target":16,"value":3},
                          {"source":21,"target":17,"value":3},
                          {"source":21,"target":18,"value":3},
                          {"source":21,"target":19,"value":3},
                          {"source":21,"target":20,"value":5},
                          {"source":22,"target":16,"value":3},
                          {"source":22,"target":17,"value":3},
                          {"source":22,"target":18,"value":3},
                          {"source":22,"target":19,"value":3},
                          {"source":22,"target":20,"value":4},
                          {"source":22,"target":21,"value":4},
                          {"source":23,"target":16,"value":3},
                          {"source":23,"target":17,"value":3},
                          {"source":23,"target":18,"value":3},
                          {"source":23,"target":19,"value":3},
                          {"source":23,"target":20,"value":4},
                          {"source":23,"target":21,"value":4},
                          {"source":23,"target":22,"value":4},
                          {"source":23,"target":12,"value":2},
                          {"source":23,"target":11,"value":9},
                          {"source":24,"target":23,"value":2},
                          {"source":24,"target":11,"value":7},
                          {"source":25,"target":24,"value":13},
                          {"source":25,"target":23,"value":1},
                          {"source":25,"target":11,"value":12},
                          {"source":26,"target":24,"value":4},
                          {"source":26,"target":11,"value":31},
                          {"source":26,"target":16,"value":1},
                          {"source":26,"target":25,"value":1},
                          {"source":27,"target":11,"value":17},
                          {"source":27,"target":23,"value":5},
                          {"source":27,"target":25,"value":5},
                          {"source":27,"target":24,"value":1},
                          {"source":27,"target":26,"value":1},
                          {"source":28,"target":11,"value":8},
                          {"source":28,"target":27,"value":1},
                          {"source":29,"target":23,"value":1},
                          {"source":29,"target":27,"value":1},
                          {"source":29,"target":11,"value":2},
                          {"source":30,"target":23,"value":1},
                          {"source":31,"target":30,"value":2},
                          {"source":31,"target":11,"value":3},
                          {"source":31,"target":23,"value":2},
                          {"source":31,"target":27,"value":1},
                          {"source":32,"target":11,"value":1},
                          {"source":33,"target":11,"value":2},
                          {"source":33,"target":27,"value":1},
                          {"source":34,"target":11,"value":3},
                          {"source":34,"target":29,"value":2},
                          {"source":35,"target":11,"value":3},
                          {"source":35,"target":34,"value":3},
                          {"source":35,"target":29,"value":2},
                          {"source":36,"target":34,"value":2},
                          {"source":36,"target":35,"value":2},
                          {"source":36,"target":11,"value":2},
                          {"source":36,"target":29,"value":1},
                          {"source":37,"target":34,"value":2},
                          {"source":37,"target":35,"value":2},
                          {"source":37,"target":36,"value":2},
                          {"source":37,"target":11,"value":2},
                          {"source":37,"target":29,"value":1},
                          {"source":38,"target":34,"value":2},
                          {"source":38,"target":35,"value":2},
                          {"source":38,"target":36,"value":2},
                          {"source":38,"target":37,"value":2},
                          {"source":38,"target":11,"value":2},
                          {"source":38,"target":29,"value":1},
                          {"source":39,"target":25,"value":1},
                          {"source":40,"target":25,"value":1},
                          {"source":41,"target":24,"value":2},
                          {"source":41,"target":25,"value":3},
                          {"source":42,"target":41,"value":2},
                          {"source":42,"target":25,"value":2},
                          {"source":42,"target":24,"value":1},
                          {"source":43,"target":11,"value":3},
                          {"source":43,"target":26,"value":1},
                          {"source":43,"target":27,"value":1},
                          {"source":44,"target":28,"value":3},
                          {"source":44,"target":11,"value":1},
                          {"source":45,"target":28,"value":2},
                          {"source":47,"target":46,"value":1},
                          {"source":48,"target":47,"value":2},
                          {"source":48,"target":25,"value":1},
                          {"source":48,"target":27,"value":1},
                          {"source":48,"target":11,"value":1},
                          {"source":49,"target":26,"value":3},
                          {"source":49,"target":11,"value":2},
                          {"source":50,"target":49,"value":1},
                          {"source":50,"target":24,"value":1},
                          {"source":51,"target":49,"value":9},
                          {"source":51,"target":26,"value":2},
                          {"source":51,"target":11,"value":2},
                          {"source":52,"target":51,"value":1},
                          {"source":52,"target":39,"value":1},
                          {"source":53,"target":51,"value":1},
                          {"source":54,"target":51,"value":2},
                          {"source":54,"target":49,"value":1},
                          {"source":54,"target":26,"value":1},
                          {"source":55,"target":51,"value":6},
                          {"source":55,"target":49,"value":12},
                          {"source":55,"target":39,"value":1},
                          {"source":55,"target":54,"value":1},
                          {"source":55,"target":26,"value":21},
                          {"source":55,"target":11,"value":19},
                          {"source":55,"target":16,"value":1},
                          {"source":55,"target":25,"value":2},
                          {"source":55,"target":41,"value":5},
                          {"source":55,"target":48,"value":4},
                          {"source":56,"target":49,"value":1},
                          {"source":56,"target":55,"value":1},
                          {"source":57,"target":55,"value":1},
                          {"source":57,"target":41,"value":1},
                          {"source":57,"target":48,"value":1},
                          {"source":58,"target":55,"value":7},
                          {"source":58,"target":48,"value":7},
                          {"source":58,"target":27,"value":6},
                          {"source":58,"target":57,"value":1},
                          {"source":58,"target":11,"value":4},
                          {"source":59,"target":58,"value":15},
                          {"source":59,"target":55,"value":5},
                          {"source":59,"target":48,"value":6},
                          {"source":59,"target":57,"value":2},
                          {"source":60,"target":48,"value":1},
                          {"source":60,"target":58,"value":4},
                          {"source":60,"target":59,"value":2},
                          {"source":61,"target":48,"value":2},
                          {"source":61,"target":58,"value":6},
                          {"source":61,"target":60,"value":2},
                          {"source":61,"target":59,"value":5},
                          {"source":61,"target":57,"value":1},
                          {"source":61,"target":55,"value":1},
                          {"source":62,"target":55,"value":9},
                          {"source":62,"target":58,"value":17},
                          {"source":62,"target":59,"value":13},
                          {"source":62,"target":48,"value":7},
                          {"source":62,"target":57,"value":2},
                          {"source":62,"target":41,"value":1},
                          {"source":62,"target":61,"value":6},
                          {"source":62,"target":60,"value":3},
                          {"source":63,"target":59,"value":5},
                          {"source":63,"target":48,"value":5},
                          {"source":63,"target":62,"value":6},
                          {"source":63,"target":57,"value":2},
                          {"source":63,"target":58,"value":4},
                          {"source":63,"target":61,"value":3},
                          {"source":63,"target":60,"value":2},
                          {"source":63,"target":55,"value":1},
                          {"source":64,"target":55,"value":5},
                          {"source":64,"target":62,"value":12},
                          {"source":64,"target":48,"value":5},
                          {"source":64,"target":63,"value":4},
                          {"source":64,"target":58,"value":10},
                          {"source":64,"target":61,"value":6},
                          {"source":64,"target":60,"value":2},
                          {"source":64,"target":59,"value":9},
                          {"source":64,"target":57,"value":1},
                          {"source":64,"target":11,"value":1},
                          {"source":65,"target":63,"value":5},
                          {"source":65,"target":64,"value":7},
                          {"source":65,"target":48,"value":3},
                          {"source":65,"target":62,"value":5},
                          {"source":65,"target":58,"value":5},
                          {"source":65,"target":61,"value":5},
                          {"source":65,"target":60,"value":2},
                          {"source":65,"target":59,"value":5},
                          {"source":65,"target":57,"value":1},
                          {"source":65,"target":55,"value":2},
                          {"source":66,"target":64,"value":3},
                          {"source":66,"target":58,"value":3},
                          {"source":66,"target":59,"value":1},
                          {"source":66,"target":62,"value":2},
                          {"source":66,"target":65,"value":2},
                          {"source":66,"target":48,"value":1},
                          {"source":66,"target":63,"value":1},
                          {"source":66,"target":61,"value":1},
                          {"source":66,"target":60,"value":1},
                          {"source":67,"target":57,"value":3},
                          {"source":68,"target":25,"value":5},
                          {"source":68,"target":11,"value":1},
                          {"source":68,"target":24,"value":1},
                          {"source":68,"target":27,"value":1},
                          {"source":68,"target":48,"value":1},
                          {"source":68,"target":41,"value":1},
                          {"source":69,"target":25,"value":6},
                          {"source":69,"target":68,"value":6},
                          {"source":69,"target":11,"value":1},
                          {"source":69,"target":24,"value":1},
                          {"source":69,"target":27,"value":2},
                          {"source":69,"target":48,"value":1},
                          {"source":69,"target":41,"value":1},
                          {"source":70,"target":25,"value":4},
                          {"source":70,"target":69,"value":4},
                          {"source":70,"target":68,"value":4},
                          {"source":70,"target":11,"value":1},
                          {"source":70,"target":24,"value":1},
                          {"source":70,"target":27,"value":1},
                          {"source":70,"target":41,"value":1},
                          {"source":70,"target":58,"value":1},
                          {"source":71,"target":27,"value":1},
                          {"source":71,"target":69,"value":2},
                          {"source":71,"target":68,"value":2},
                          {"source":71,"target":70,"value":2},
                          {"source":71,"target":11,"value":1},
                          {"source":71,"target":48,"value":1},
                          {"source":71,"target":41,"value":1},
                          {"source":71,"target":25,"value":1},
                          {"source":72,"target":26,"value":2},
                          {"source":72,"target":27,"value":1},
                          {"source":72,"target":11,"value":1},
                          {"source":73,"target":48,"value":2},
                          {"source":74,"target":48,"value":2},
                          {"source":74,"target":73,"value":3},
                          {"source":75,"target":69,"value":3},
                          {"source":75,"target":68,"value":3},
                          {"source":75,"target":25,"value":3},
                          {"source":75,"target":48,"value":1},
                          {"source":75,"target":41,"value":1},
                          {"source":75,"target":70,"value":1},
                          {"source":75,"target":71,"value":1},
                          {"source":76,"target":64,"value":1},
                          {"source":76,"target":65,"value":1},
                          {"source":76,"target":66,"value":1},
                          {"source":76,"target":63,"value":1},
                          {"source":76,"target":62,"value":1},
                          {"source":76,"target":48,"value":1},
                          {"source":76,"target":58,"value":1}
                    ];
        }



	for (i=0; i<nodi.length; i++) {
		nodi[i].x=random()*width;
		nodi[i].y=random()*height;
		nodi[i].dispx=0;
		nodi[i].dispy=0;
		nodi[i].links = 0;
		nodi[i].dragging = false;
		nodi[i].index = i;
	}

	for (i=0; i<links.length; i++)	{
		//	nodi[links[i].source].links += 1;
		//	nodi[links[i].target].links += 1;
		links[i].source = nodi[links[i].source];
		links[i].target = nodi[links[i].target];
	
		linkedByIndex[links[i].source.index + "," + links[i].target.index] = 1;
	
	}

	function zoomed() {
		container.attr("transform", "translate(" + d3.event.translate + ")scale(" + d3.event.scale + ")");
	}

	var zoom = d3.behavior.zoom()
    			.scaleExtent([0.01, 10])
    			.on("zoom", zoomed); 

	svg = d3.select("svg")
				.attr("width", width)
    				.attr("height", height)
    				.attr("id", "svg")
    				.attr("style", "border-style: solid")
    				.call(zoom);

	var container = svg.append("g");  // è la gravità. Perché la appendiamo qui?

	link = container.selectAll("line")
			  .data(links)
			  .enter()
			  .append("line")
			  .attr("stroke-width", "1")
			  .attr("stroke", "#999")
			  .attr("fill", "transparent");

	nodi2 = container.selectAll("circle")
			   .data(nodi)
			   .enter()
			   .append("circle")
			   .attr("fill", "#E00000")
			   .style("fill", function(d) { return color(d.group); })
			   .attr("r", "5");
   
	nodi2.append("title")
	      .text(function(d) { return d.name; });

	var k_el = document.getElementById("charge").value;
	var k_springf = 1/(document.getElementById("linkStrength").value);
	var k_springl = document.getElementById("linkDistance").value;
	var gravity = document.getElementById("gravity").value;
	var iterations = document.getElementById("iterations").value;

	for (k=0; k<iterations; k++){
		setTimeout(mainStep(k_el, k_springf, k_springl, gravity), 100);
	} 
               
	function isConnected(a, b) {
		return linkedByIndex[a.index + "," + b.index] || linkedByIndex[b.index + "," + a.index];
	}

	nodi2.on("mouseover", function(d) {
	        nodi2.classed("node-active", function(o) {
			thisOpacity = isConnected(d, o) ? true : false;
			this.setAttribute('fill-opacity', thisOpacity);
	                return thisOpacity;
	        });

	        link.classed("link-active", function(o) {
	        	return o.source === d || o.target === d; 
	        });
		d3.select(this).classed("node-active", true);
                        
        }).on("mouseout", function(d){
		nodi2.classed("node-active", false);
                link.classed("link-active", false);
        });


	var drag = d3.behavior.drag()
    			.origin(function(d) { return d; })
    			.on("dragstart", function() {
 			 	d3.event.sourceEvent.stopPropagation();
 			 	d3.select(this).attr("dragging", function(d) {
 			 		d.dragging = true;
 			 		return true;
 			 	
 			 	});
			}).on("drag", function(d){
    				mainStep(k_el, k_springf, k_springl, gravity);
    				d3.select(this).attr("cx", d.x = d3.event.x).attr("cy", d.y = d3.event.y);
    		
    
    			}).on("dragend", function (d){
    				d3.select(this).attr("dragging", function(d) {
 			 		d.dragging = false;
 			 		return false;
 			 	});

    				for (p=0; p<1000; p++)
					setTimeout(mainStep(k_el, k_springf, k_springl, gravity), 100);
					//mainStep(k_el, k_springf, k_springl);
    			});

	nodi2.call(drag);
	var color = d3.scale.category20();

} 

function resume(){

	var k_el = document.getElementById("charge").value;
	var k_springf = 1/(document.getElementById("linkStrength").value);
	var k_springl = document.getElementById("linkDistance").value;
	var gravity = document.getElementById("gravity").value;
	var iterations = document.getElementById("iterations").value;

	for (k=0; k<iterations; k++){
		setTimeout(mainStep(k_el, k_springf, k_springl, gravity), 100);
	} 
} 


function mainStep(k_e, k_sf, k_sl, gravity){ 
	setTimeout(function (){  

	// forze repulsive
	//
	for (o=0; o<nodi.length; o++) {
		for (l=0; l<nodi.length; l++) {
		if (o!=l){
			var v = nodi[o];
			var u = nodi[l];
			if (!v.dragging){
			var distx = (v.x) - (u.x);
			var disty = (v.y) - (u.y);
		
			var dist = Math.sqrt(distx*distx + disty*disty);
	//		v.dispx += (k_el/dist)*(distx/dist)*(u.links/2);
	//		v.dispy += (k_el/dist)*(disty/dist)*(u.links/2);
			v.dispx += (k_e/dist)*(distx/dist);
			v.dispy += (k_e/dist)*(disty/dist);
				}
			}
		}
		
	} 

	for (h=0; h<links.length; h++) {
	
		var v = links[h].source;
		var u = links[h].target;
		vx = v.x;
		vy = v.y;
		ux = u.x;
		uy = u.y;
		var distx = vx - ux;
		var disty = vy - uy;
		if(distx < 1 && distx > -1) distx = 1;
		if(disty < 1 && disty > -1) disty = 1;
		var dist = Math.sqrt(Math.pow(distx, 2) + Math.pow(disty, 2));
		if (!v.dragging){
			v.dispx -= k_sf*(dist-k_sl)*(distx/dist);
			v.dispy -= k_sf*(dist-k_sl)*(disty/dist);
		}
		if (!u.dragging){
			u.dispx += k_sf*(dist-k_sl)*(distx/dist);
			u.dispy += k_sf*(dist-k_sl)*(disty/dist);
		}
	} 

	for (j=0; j<nodi.length; j++) {
		var xp = nodi[j].x;
		var xd =  nodi[j].dispx;
		var yp = nodi[j].y;
		var yd =  nodi[j].dispy;
		var a = xp + xd;
		var b = yp + yd;
		
		if (!nodi[j].dragging){
			var distx = a - (width/2);     // distanza x dal centro dello schermo
			var disty = b - (height/2);    // distanza y dal centro dello schermo
			var dist = Math.sqrt(distx*distx + disty*disty); // distanza assoluta dal centro dello schermo
		}
		
		nodi[j].dispx -= (dist*gravity)*(distx/dist);  // sommo allo spostamento uno spostamento di gravità
		nodi[j].dispy -= (dist*gravity)*(disty/dist); 
		
		
		var x = nodi[j].x + nodi[j].dispx; // come a e b no?
		var y = nodi[j].y + nodi[j].dispy; 
		
		nodi[j].x += nodi[j].dispx;
		nodi[j].y += nodi[j].dispy;
		nodi[j].dispx = 0;
		nodi[j].dispy = 0;
	}
	
	link.attr("x1", function(d){return d.source.x})
		.attr("y1", function(d){return d.source.y})
		.attr("x2", function(d){return d.target.x})
		.attr("y2", function(d){return d.target.y});
	
	nodi2.attr("cx", function(d) {return d.x})
	 	.attr("cy", function(d) {return d.y});

	
	
	}, 100); 

}



function random() {
    var x = Math.sin(seed++) * 10000;
    return x - Math.floor(x);
}

</script>
</body>
</html>
